// KEKS/CM -- KEKS-encoded cryptographic messages
// Copyright (C) 2024-2025 Sergey Matveev <stargrave@stargrave.org>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation, version 3 of the License.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this program.  If not, see <http://www.gnu.org/licenses/>.

package chapoly

import (
	"crypto/rand"
	"errors"

	"golang.org/x/crypto/chacha20poly1305"
)

func Wrap(kek, cek []byte) ([]byte, error) {
	nonce := make([]byte, chacha20poly1305.NonceSizeX)
	rand.Reader.Read(nonce)
	ciph, err := chacha20poly1305.NewX(kek)
	if err != nil {
		return nil, err
	}
	return append(nonce, ciph.Seal(nil, nonce, cek, nil)...), nil
}

func Unwrap(kek, encap []byte) ([]byte, error) {
	if len(encap) <= chacha20poly1305.NonceSizeX+chacha20poly1305.Overhead {
		return nil, errors.New("encap is too small")
	}
	ciph, err := chacha20poly1305.NewX(kek)
	if err != nil {
		return nil, err
	}
	return ciph.Open(
		nil,
		encap[:chacha20poly1305.NonceSizeX],
		encap[chacha20poly1305.NonceSizeX:],
		nil,
	)
}
